function removeFromArray(arr, removeItem) {
  return jQuery.grep(arr, function(value) {
      return value != removeItem;
  });
}

function is_int(value) {
    reg_int = new RegExp("^[0-9]+$");
    return !isNaN(value) && reg_int.test(value)
}

function loadPage(page, initFunc){
  $("#ajax-loader").show();
  $.ajax({
    url: '/' + page,
    type: 'POST',
    data: {},    // set empty data because of Fx 3.0.x
    success: function(data, textStatus) {
      $("#contenu").html(data);
      initFunc();
      $("#ajax-loader").hide();
    }
  });
}



$(document).ready(function() {
    getActus();
    loadPage('accueil', loadRegister);
    updateStatus();
});

function loadRegister() {
  // Le formulaire d'enregistrement est déjà pré-rempli
}

function registerSubmit(){
    $("#progressbar-root").show();
    $("#progressbar").progressbar({ value: 25 });
    $("#registerform input, #registerform button").attr("disabled", true);
    
    $.post("register",
        {
          "user": $("#register-user").val(),
          "key" : $("#register-key").val(),
          "server_hostname" : $("#server_hostname").val()
        },
        function(data){
            if(data.success) {
              loadPage('accueil', loadRegister);
            } else {
              display_popup("Attnetion", lang.register.error +"\n"+ data.params.msg);
            }
            
            $("#registerform input, #registerform button").attr("disabled", false);
            $("#progressbar").progressbar({ value: 100 });
            $("#progressbar-root").hide();
        },
        "json"
    );
}

function display_popup(titre, message) {
  $("#dialog-modal")
    .html(message)
    .attr("title", titre)
    .dialog({
      height: 140,
      modal: true,
      buttons: {
        Ok: function() {
          $( this ).dialog( "close" );
        }
      }
    });
}

function updateStatus() {
  $("#status").empty().text("Mise à jour...");
  $.post("/checkports",
        {},
        function(data){
            $("#status").empty()
            $.each(data, function(index, testedport) {
                $("#status").append(
                  $("<span>").attr("title", testedport.message).append(
                    $("<img>").attr(
                      { "src" : "/images/status-"+testedport.status+".png",
                        "alt" : testedport.status }
                    ),
                    testedport.portnumber
                  )
                )
            });
        },
       "json"
  );
}
