

var include = [];
var exclude = [];

function loadTree() {
  $("#tree-div").jstree({ 
    "json_data" : {
      "ajax" : {
        "url" : "/getNodeChildren",
        "type": "POST",
        "data" : function (n) {
            return { node : n.attr ? n.attr("node") : "__root__" }; 
        }
      }
    },
    "plugins" : [ "themes", "json_data" ]
  }).bind("loaded.jstree", function (event, data) {
    // Rend la racine draggable sans la charger
    $( ".draggable" ).draggable({ helper: "clone", handle: "a"});
  });
  
  $("#tree-div").delegate("a", "dblclick", function (event, data) {
    $.jstree._reference(($(this).parent())).toggle_node($(this).parent())
    event.preventDefault();
  }).delegate("a", "click", function (event, data) {
    event.preventDefault();
  });
  

  
  $("div").bind("after_open.jstree", function (event, data) {
    $( ".draggable" ).draggable({ helper: "clone", handle: "a"});
  });
  
 
  $( "#panier-include" ).droppable({
    drop: function( event, ui ) {
      var node = ui.draggable;
      addBackupItem(node);
      return true;
    }
  });
  
    $( "#panier-exclude" ).droppable({
    drop: function( event, ui ) {
      var node = ui.draggable;
      addExcludeItem(node);
      return true;
    }
  });
    
    $(".param-panel textarea, .param-panel input, .param-panel select").bind("blur", function() {
      if($("#__max_send_speed").val() != '' && !is_int($("#__max_send_speed").val() ))
      {
        display_popup("Attention", 'La limite maximum de la bande passante pour l\'upload doit être un entier exprimé en octet/s');
        $("#__max_send_speed").val("");
        return;
      }
      
      if($("#__max_recv_speed").val() != '' && !is_int($("#__max_recv_speed").val() ))
      {
        display_popup("Attention", 'La limite maximum de la bande passante pour le download doit être un entier exprimé en octet/s');
        $("#__max_recv_speed").val("");
        return;
      }
      saveConfig();
    });
    
    $(".param-panel input[type=checkbox]").bind("click", function() {
      saveConfig();
    });
    
    if($.client.os != "Windows") {
      $(".win-only").hide();
    }
 
    updateBackupList();
    updateExcludeList();
    updateCheckboxes();
    updateTimeBackup();
}

          
function addBackupItem(node){
    include.push({
        id: $(node).attr("path")
        ,
        path: $(node).attr("path")
        ,
        leaf: $(node).attr("leaf")
    });
    saveConfig();
}
            
function addExcludeItem(node){
    exclude.push({
        id: $(node).attr("path")
        ,
        path: $(node).attr("path")
        ,
        leaf: $(node).attr("leaf")
    });
    saveConfig();
}

function removeBackupItem(node_id){
            
    $.each(include, function(index, node_item){
        if (node_item) {
            if (unescape(node_id) == node_item.id) 
                include.splice(index, 1);
        }
    });
    saveConfig();
}
            
function removeExcludeItem(node_id){
            
    $.each(exclude, function(index, node_item){
        if (node_item) {
            if (unescape(node_id) == node_item.id) 
                exclude.splice(index, 1);
        }
    });
    saveConfig();
}

function saveConfig(){
    $("#ajax-loader").show()
    var _included = $.map(include, function(el){
        return el.id;
    });
                
    var _excluded = $.map(exclude, function(el){
        return el.id;
    });
    
   
    $.post("/saveConfig", {
      include: JSON.stringify(_included),
      exclude: JSON.stringify(_excluded),
      excludepattern: $("#textarea-excludepattern").val(),
      hour: $("#hourBackup").val(),
      min: $("#minBackup").val(),
      shutDownAfterBackup: ($("#__shutDownAfterBackup").attr('checked')) ? "True" : "False",
      max_send_speed: $("#__max_send_speed").val(),
      max_recv_speed: $("#__max_recv_speed").val(),
      use_vss: ($("#__use_vss").attr('checked')) ? "True" : "False"
    },
      function(data){
          include = data.include;
          exclude = data.exclude;
          $("#excludePattern").val(data.excludepattern);
          updateBackupList();
          updateExcludeList();
          $("#ajax-loader").hide()
      },
      "json"
    );
    
}


function updateBackupList(){
    $("#panier-include").empty();
    $.each(include, function(index, node){
        var item = "<div name='"+escape(node.id)+"' class='folderlist'>"+
                   "<a href='#' onclick='removeBackupItem(\""+escape(node.id)+"\");return false;'>"+
                   "<img src='/images/delete.gif'/></a>"+
                   "<img class='icon' src='/images/jstree/"+(node.leaf ? 'leaf' : 'folder')+".gif'/>"+
                   "<span>"+node.path+"</span>"+
                   "</div>";
        $("#panier-include").append($(item));
        
    });
}
            
function updateExcludeList(){
    $("#panier-exclude").empty();
    $.each(exclude, function(index, node){
        var item = "<div name='"+escape(node.id)+"' class='folderlist'>"+
                   "<a href='#' onclick='removeExcludeItem(\""+escape(node.id)+"\");return false;'>"+
                   "<img src='/images/delete.gif'/></a>"+
                   "<img class='icon' src='/images/jstree/"+(node.leaf ? 'leaf' : 'folder')+".gif'/>"+
                   "<span>"+node.path+"</span>"+
                   "</div>";
        $("#panier-exclude").append($(item));
        
    });
}

function updateCheckboxes() {
  $(".param-panel input[type=checkbox]").each(function(index, input) {
    if($(input).val() == "True")
      $(input).attr("checked", true);
    else
      $(input).attr("checked", false);
  });
}

function updateTimeBackup() {
  var hour = $("#hourBackup").attr("data-value");
  var min = $("#minBackup").attr("data-value");
  if(hour.length == 1)  hour = "0"+hour;
  if(min.length == 1)   min = "0"+min;
  
  $("#hourBackup").val(hour);
  $("#minBackup").val(min);

}


function runBackup(){
    src = "runBackup";
    showConsole(src);
}